# include <pthread.h>
# include <stdio.h>
# include "Mutex.h"
# include "Time.h"

int thread_id = 1;
extern int delay     = 0;

pthread_mutex_t mutex;
pthread_mutexattr_t mutex_attr;

/*
 * This function is used for generating the thread id for each of the
 * threads. Depending on the command line arguement, this function
 * optionally generates the a delay by calling the delay_loop fn.
 */

extern int get_thread_id (void)
{
    int id;
    
    printf ("Locking the Mutex \n");
    fflush (stdout);
    
    /* Get a lock on the global shared variable */
    pthread_mutex_lock (&mutex);

    /* ----- Critical Section ------*/
    if (delay == 1)
      delay_loop (); 

    id = thread_id++;
    /* -------End Critical Section ---*/

    /* Unlock the Mutex */
    pthread_mutex_unlock (&mutex);

    return id;
}

/*
 * releases the mutex lock
 */

extern void destroy_mutex (void)
{
   pthread_mutex_destroy (&mutex);
}

/*
 * initializes the Mutex.
 */
extern void initialize_mutex (void)
{
   pthread_mutex_init (&mutex, &mutex_attr);
}

/*
 * sets the delay to true or false
 */
extern void set_delay (int wait)
{
   delay = wait;
}



