# include <time.h>
# include <sys/time.h>

# include "Time.h"

/*
 * time_wasting() function is the computation performed by each thread as a part of the
 * busy wait. This is a junk computation and takes a fixed
 * amount of time.
 *
 * Basically number_of_iterations * time for the this function = wait_period
 */

void time_wasting_function (void)
{
   int counter =0;
   counter = (counter +1)/ 100 * counter + 3;
}

/*
 * delay_loop() is a time consuming function that is run by the get_thread_id ()
 * function if the command line argument given is 1. Else the loop is not run.
 * This function just wasts some time by calling the time_wasting_function!!
 */

extern void delay_loop (long iterations)
{
    long counter;
    for (counter =0; counter < iterations; counter++)
       time_wasting_function ();
}


/*
 * The calibration loop is run apriori *calibration_iteration* times to
 * correctly measure the number of iterations that have to elapse for the
 * time_wasting() to complete one second.
 */

extern long calibration_loop (int wait_period)
{
   struct timeval current_time, loop_time;
   long counter =1;

   /*--- Get the time now and run the time wasting loop to complete one sec --*/
   gettimeofday (&current_time,NULL);
   do
   {
       time_wasting_function ();
       counter++;
       gettimeofday (&loop_time,NULL);
   }while (loop_time.tv_sec <= current_time.tv_sec + wait_period);
   
   return counter;
}
